library custompopchoice;

import 'package:flutter/material.dart';

class PopupChoice extends StatefulWidget {
  List<CustomListile> item;
  Function onTap;
  String title;
  double heigh;
  PopupChoice(
      {@required this.item,
      @required this.onTap,
      @required this.title,
      this.heigh});
  @override
  _PopupChoiceState createState() => _PopupChoiceState();
}

class _PopupChoiceState extends State<PopupChoice> {
  @override
  Widget build(BuildContext context) {
    return ClipRRect(
      child: SafeArea(
        child: Container(
          margin: EdgeInsets.all(20),
          decoration: BoxDecoration(
            color: Colors.white,
            borderRadius: BorderRadius.circular(20),
          ),
          height: widget.heigh != null ? widget.heigh : 300,
          width: double.infinity,
          child: Container(
            decoration: BoxDecoration(
              borderRadius: BorderRadius.circular(20),
            ),
            child: Stack(
              alignment: Alignment.center,
              children: [
                Positioned(
                  top: 7,
                  child: Container(
                    height: 4,
                    decoration: BoxDecoration(
                      borderRadius: BorderRadius.circular(4),
                      color: Color(0xffE0E0E0),
                    ),
                    width: 42,
                  ),
                ),
                Positioned(
                  left: 0.0,
                  right: 0.0,
                  top: 10,
                  child: Column(
                    mainAxisAlignment: MainAxisAlignment.start,
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: [
                      Padding(
                        padding: const EdgeInsets.symmetric(
                            vertical: 10, horizontal: 20),
                        child: Text(widget.title,
                            style: TextStyle(
                              fontSize: 16,
                              color: Color(0xff828282),
                              fontFamily: 'PoppinMedium',
                            )),
                      ),
                      SingleChildScrollView(
                        child: Column(
                          children: widget.item.map((e) {
                            return GestureDetector(
                              onTap: () {
                                widget.onTap(e);
                                Navigator.pop(context);
                              },
                              child: CustomListile(
                                label: e.label,
                                icon: e.icon,
                              ),
                            );
                          }).toList(),
                        ),
                      )
                    ],
                  ),
                ),
              ],
            ),
          ),
        ),
      ),
    );
  }
}

class CustomListile extends StatelessWidget {
  final String label;
  final Widget icon;

  CustomListile({
    @required this.label,
    this.icon,
  });
  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        Container(height: 1, width: double.infinity, color: Color(0xffE0E0E0)),
        Container(
          height: 50,
          color: Colors.white,
          child: Row(
            children: [
              Padding(
                  padding:
                      const EdgeInsets.symmetric(horizontal: 20, vertical: 10),
                  child: icon),
              Text(label,
                  style: TextStyle(
                    fontSize: 16,
                    color: Colors.black,
                    fontFamily: 'PoppinMedium',
                  ))
            ],
          ),
        ),
      ],
    );
  }
}
